-----------------------------------------------------------------------------------------------------------------
-- SANTEX FUNCTIONS LIBRARY ----------------------------------------------------------------------------------------
	-------------------------------------------------------------------------------------------------------------
	-- !!! VARIABLES NEEDED !!! (specify these before 'include "santex_fnlib.ms"'):
	-- -- -- maintitle <string>
	-- -- -- copyright <string>
	-- -- -- configfile <filename_string>
	-- -- -- devlogfile <filename_string>
	--
	-- FUNCTIONS:
-- MESSAGES errormsg, warningmsg
	-- --fatalerrormsg <string> <array>							/--fatalerrormsg errtxt (#(settingname,settingvalue)) UNUSED !!!
	-- errorMsg <string>
	-- warningMsg <string>										/warningmsg "This cannot be undone."
	--
-- DIALOG slib.dlg
	-- slib.dlg.setPos <rollout> <point2>						/slib.dlg.setpos et10 [0,0]
	-- slib.dlg.setPosCursor <rollout>							/slib.dlg.setposcursor et10
	-- ** <point2> slib.dlg.setPosScreen <rollout>				/slib.dlg.setposscreen et10
	-- ** <point2> slib.getPos <rollout>
	-- slib.dlg.setSize <rollout> <point2>						/slib.dlg.setsize et10 [305,256]
	-- ** <point2> slib.dlg.getSize <rollout>						/et.sys.dlgmainsize=slib.dlg.getsize et10
	-- <point2> slib.dlg.resizeLim <rollout> <point2> <point2> <point2>	/et.sys.dlgmainsize=slib.dlg.resizelim et10 newsize [304,256] [800,800]
	--
-- FILE slib.file
	-- <boolean> slib.file.init <filename> <string>				/if slib.file.init devlogfilename "Dev Log" do...
	-- <boolean> slib.file.exist <filename>						/if slib.file.exist devlogfilename then...
	-- ** <string> slib.file.path <filename>
	-- ** <string> slib.file.name <filename>
	-- ** <string> slib.file.type <filename>
	--  <float> slib.file.size <filename> <integer>				/size=slib.file.size myfilename 2 /(0=B, 1=kB, 2=MB)
	-- ** <boolean> slib.file.delete <filename>
	-- ** <boolean> slib.file.copy <filename>
	-- ** <boolean> slib.file.move <filename>
	-- ** <filename> slib.file.rename <filename> <string>		/slib.file.rename devlogfile "santex_devlog.txt"
	--
-- WORKING DIALOG slib.workdlg
	-- slib.workDlg.open()
	-- slib.workDlg.job <string>								/slib.workdlg.job "Updating..."
	-- slib.workDlg.close()
	--
-- SCENE DATA slib.data
	-- slib.data.save <integer id> <value>				/slib.data.save 1 filepath
	-- <string> slib.data.load <integer id>			/filepath=slib.data.load 1
	--
-- SETTINGS slib.setting
	-- slib.setting.save <string> <value>						/slib.setting.save "dlgsize" et.sys.dlgsize
	-- <value> slib.setting.load <string> <value>				/et.sys.dlgsize=slib.setting.load "dlgsize" et.sys.dlgsize
	-- <string> slib.setting.loadStr <string> <string>			/et.sys.texpath=slib.setting.loadstr "texpath" "C:\3dmax9\"
	--
-- CUSTOM FILE SETTINGS slib.csetting
	-- slib.csetting.save <filepath> <category> <string> <value>						/slib.csetting.save bak_file "General" "dlgsize" et.sys.dlgsize
	-- <value> slib.csetting.load <filepath> <category> <string> <value>				/et.sys.dlgsize=slib.csetting.load "C:\dialog.ini" "Dlg" "dlgsize" et.sys.dlgsize
	-- <string> slib.csetting.loadStr <filepath> <category> <string> <string>			/et.sys.texpath=slib.csetting.loadstr file category "texpath" "C:\3dmax9\"
	--
-- STRING ARRAY slib.sarray (santex array)
	-- <array> slib.sarray.getarray <string> <string> <integer>	/arry=slib.sarray.getarray "12x25" "x" 0 (arry=#("12","25")) (0 - string mode, 1 - integer mode)
	-- <integer> slib.sarray.getint <string> <string> <integer>	/sel=slib.sarray.getint "12x25" "x" 1 (sel=12) (1 - return 1st number from array, 2 - second, 3 - third...)
	-- <string> slib.sarray.getstr <string> <string> <integer>	/name=slib.sarray.getstr "john:kok:santex" ":" 1 (name="john") (1 - return 1st string from array, 2 - second, 3 - third...)
	-- <string> slib.sarray.setval <string> <string> <integer> <value>
	-- <string> slib.sarray.append <string> <string> <value>	/names=slib.sarray.append names ";" "john"
	-- <integer> slib.sarray.count <string> <string>			/a_cnt=slib.sarray.count "12,1,50" "," (a_cnt=3)
	--
-- OTHER
	-- <boolean> slib.isCorrectMaxVersion <integer>				/if (slib.isCorrectMaxVersion 9000) do
	-- <string> slib.tolowercase <string>						/et.sys.text=slib.tolowercase edtName.text
	-- <string> slib.touppercase <string>						/et.sys.text=slib.touppercase edtName.text
	-- <string> slib.getShortString <string> <integer>			/filepath=slib.getShortString filepath 100 (each letter is calculated as 5px wide)
	-- <array> slib.clearDups <array>							/et.ses.filearray=slib.cleardups et.ses.filearray
	-- <array> copyarray <array>								/myarray=copyarray oldarray (copy array item by item)
	--
-- VALUE TESTS
	-- <boolean> isRollout <anything>							/if isRollout et10 do..
	-- <boolean> isPoint2 <anything>							/if isPoint2 [1,1] do..
	-- <boolean> isString <anything>							/if isString "kok" do..
	-- <boolean> isArray <anything>								/if isArray #("a") do..
	-- <boolean> isBoolean <anything>							/if isBoolean true do..
	-- <boolean> isInteger <anything>							/if isInteger 5 do..

/*fn use_global_vars vars_struct=
(
	maintitle=vars_struct.maintitle
	copyright=vars_struct.copyright
	cfgdir=vars_struct.cfgdir
	configfile=vars_struct.configfile
	devlogfile=vars_struct.devlogfile
	fatalerror=vars_struct.fatalerror
)*/
/*
global slib_vars
local maintitle=slib_vars.maintitle
local copyright=slib_vars.copyright
local cfgdir=slib_vars.cfgdir
local configfile=slib_vars.configfile
local devlogfile=slib_vars.devlogfile
local fatalerror=slib_vars.fatalerror*/

/*
execute "maintitle=slib_vars.maintitle"
execute "copyright=slib_vars.copyright"
execute "cfgdir=slib_vars.cfgdir"
execute "configfile=slib_vars.configfile"
execute "devlogfile=slib_vars.devlogfile"
execute "fatalerror=slib_vars.fatalerror"*/

mapped fn delete_all o=
(
	try(delete o)catch()
)
mapped fn close_rollouts r=
(
	try(destroydialog r)catch()
)

fn isRollout dlg=
(if (classof dlg)==RolloutClass then return true else return false)
fn isPoint2 val=
(if (classof val)==Point2 then return true else return false)
fn isString str=
(if (classof str)==String then return true else return false)
fn isArray a=
(if (classof a)==Array then return true else return false)
fn isBoolean bool=
(if (classof bool)==BooleanClass then return true else return false)
fn isInteger num=
(if (classof num)==Integer then return true else return false)

/*
fn --fatalerrormsg inFunction valuesArray=
(
	if not fatalerror do
	(
		local fatalerrordlg
		global fatalerrorparams=#(inFunction,valuesArray,8)
		if fatalerrorparams[2].count<8 do
		(fatalerrorparams[3]=fatalerrorparams[2].count)
		
		rollout fatalerrordlg "" width:350 height:210
		(		
			label lbl1 "Critical error occured. See details below:"
			label lblFN " " pos:[14,32] width:320 height:40
			listbox lbxVal items:#() height:fatalerrorparams[3]
			button btnContinue "Continue" width:80 pos:[8,8]
			button btnOpen "Show Log" width:123 pos:[92,8] enabled:false
			button btnEnd "END"	width:123 pos:[219,8]
			
			on btnContinue pressed do
			(
				fatalerror=false
				destroydialog fatalerrordlg
			)
			on btnOpen pressed do
			(
				shelllaunch devlogfile ""
			)
			on btnEnd pressed do
			(
				destroydialog fatalerrordlg
				--print maintitle
			--execute ("destroydialog "+maintitle) --<<<
			)
			on fatalerrordlg open do
			(
				fatalerror=true
				local lbxVal_items=#()
				fatalerrordlg.title=(" "+maintitle+" - Error Debugger")
				lblFN.text=("In function:\n"+fatalerrorparams[1])
				if doesfileexist devlogfile do btnOpen.enabled=true
				for v in fatalerrorparams[2] do
				(
					append lbxVal_items ((v as string)+"  - <"+((classof v)as string)+">")
				)
				lbxVal.items=lbxVal_items
				
				btnContinue.pos.y=(fatalerrordlg.height-28)
				btnOpen.pos.y=(fatalerrordlg.height-28)
				btnEnd.pos.y=(fatalerrordlg.height-28)
			)
		)
		createdialog fatalerrordlg style:#(#style_toolwindow,#style_sysmenu) modal:true
	)--end if fatalerror
)*/

fn warningmsg text=								--displays warning message with custom text
(
	txt="Warning:\n\n"
	txt+=text
	
	messagebox txt title:maintitle beep:true
)
fn errormsg text=								--displays warning message with custom text
(
	txt="Error:\n\n"
	txt+=text
	
	messagebox txt title:maintitle beep:true
)
/*local settscategory="General"*/
struct scene_data_struct
(
	fn save id val=
	(
		setAppData rootNode id (val as string)
	),
	fn load id=
	(
		local data=getAppData rootNode id
		return data
	),
	fn delete id=
	(
		deleteAppData rootNode id
	)
)
struct settings_struct
(
	fn save settingname settingvalue=		--save value to ini file
	(
		if category==undefined do category="General"
		try (
			setinisetting configFile category settingName (settingValue as string)
		)catch(
			errtxt="slib.setting.save settingName settingValue\n"
			errtxt+="slib.setting.save <string> <value>"
			--fatalerrormsg errtxt (#(settingname,settingvalue))
		)
	),
	fn load settingname defaultsetting=		--load value from ini file
	(
		if category==undefined do category="General"
		local currentSetting
		try (
			currentSetting=(execute (GetIniSetting configFile category settingName))
			if ((currentSetting==OK) or (currentSetting==undefined)) then
			(
				setinisetting configFile category settingName (defaultSetting as string)
				currentSetting=defaultSetting
			)
		)catch(
			errtxt="currentSetting slib.setting.load settingName defaultSetting\n"
			errtxt+="<value> slib.setting.load <string> <value>"
			--fatalerrormsg errtxt (#(currentSetting,settingname,defaultsetting))
		)
		return currentSetting
	),
	fn loadStr settingname defaultsetting=	--load string value from ini file
	(
		if category==undefined do category="General"
		local currentSetting
		try (
			currentSetting=((GetIniSetting configFile category settingName) as string)
			if ((currentSetting==OK) or (currentSetting==undefined) or (currentSetting=="")) then
			(
				setinisetting configFile category settingName (defaultSetting as string)
				currentSetting=defaultSetting
			)
		)catch(
			errtxt="currentSetting slib.setting.loadStr settingName defaultSetting\n"
			errtxt+="<string> slib.setting.loadStr <string> <string>"
			--fatalerrormsg errtxt (#(currentSetting,settingname,defaultsetting))
		)
		return currentSetting
	)
)
struct customfile_settings_struct
(
	fn save file category settingname settingvalue=		--save value to ini file
	(
		--if category==undefined do category="General"
		try (
			setinisetting file category settingName (settingValue as string)
		)catch(
			errtxt="slib.setting.save settingName settingValue\n"
			errtxt+="slib.setting.save <string> <value>"
			--fatalerrormsg errtxt (#(settingname,settingvalue))
		)
	),
	fn load file category settingname defaultsetting=		--load value from ini file
	(
		--if category==undefined do category="General"
		local currentSetting
		try (
			currentSetting=(execute (GetIniSetting file category settingName))
			if ((currentSetting==OK) or (currentSetting==undefined)) then
			(
				setinisetting file category settingName (defaultSetting as string)
				currentSetting=defaultSetting
			)
		)catch(
			errtxt="currentSetting slib.setting.load settingName defaultSetting\n"
			errtxt+="<value> slib.setting.load <string> <value>"
			--fatalerrormsg errtxt (#(currentSetting,settingname,defaultsetting))
		)
		return currentSetting
	),
	fn loadStr file category settingname defaultsetting=	--load string value from ini file
	(
		--if category==undefined do category="General"
		local currentSetting
		try (
			currentSetting=((GetIniSetting file category settingName) as string)
			if ((currentSetting==OK) or (currentSetting==undefined) or (currentSetting=="")) then
			(
				setinisetting file category settingName (defaultSetting as string)
				currentSetting=defaultSetting
			)
		)catch(
			errtxt="currentSetting slib.setting.loadStr settingName defaultSetting\n"
			errtxt+="<string> slib.setting.loadStr <string> <string>"
			--fatalerrormsg errtxt (#(currentSetting,settingname,defaultsetting))
		)
		return currentSetting
	),
	fn del file category keyname:undefined=
	(
		if keyname==undefined then delIniSetting file category
			else delIniSetting file category keyname
	)
)
struct filefunctions_struct
(
	fn init filetoinit description=			--checks if file exist and initialize file header if its not present
	(
		local fnresult=false
		try(
		if not (doesfileexist filetoinit) do
		(
			try(makeDir (getFilenamePath filetoinit) all:true)catch()
			newfile=createFile filetoinit
			format "% % [Created: %]\n" maintitle description localTime to:newfile
			format "%\n\n" copyright to:newfile
			flush newfile
			close newfile
			fnresult=true
		)
		)catch(
			--fatalerrormsg "<boolean> slib.file.init <filename string> <string>" (#(fnresult,filetoinit,description))
		)
		return fnresult
	),
	fn exist filenameString=
	(
		try(
		local fnresult=false
		if (doesfileexist filenameString) do fnresult=true
		return fnresult
		)catch(return false)
	),
	fn name filenamePath=
	(
		local returnname=""
		if isString filenamePath then
		(
			returnname=filenamefrompath filenamePath
		)else
		(
			errtxt="returnname slib.file.name filenamePath\n"
			errtxt+="<string> slib.file.name <string>"
			--fatalerrormsg errtxt #(returnname,filenamePath)
		)
		return returnname
	),
	fn size filenamePath type=
	(
		local filesize=0.
		filesize=getfilesize filenamePath
		case type of
		(
			0: filesize=(filesize/1.)
			1: filesize=(filesize/1000.)
			2: filesize=(filesize/1000000.)
		)
		return filesize
	)
)
fn dlgOnScreen dlg pos=		--checks if dialog will appear on screen, returns correct pos
(
	local scrSize=[(systemTools.GetScreenWidth()-8),(systemTools.GetScreenHeight()-56)]
	local dlgpos=[pos.x,pos.y]
	
	if pos.x<0 do dlgpos.x=0
	if pos.y<0 do dlgpos.y=0
	if (pos.x+dlg.width)>(scrSize.x) do dlgpos.x=(scrSize.x-dlg.width)
	if (pos.y+dlg.height)>(scrSize.y) do dlgpos.y=(scrSize.y-dlg.height)
	
	return dlgpos
)
struct dialogfunctions_struct
(
	fn setSize dialog newsize=				--set dialog size
	(
		local dlgsize=[0,0]
		if isRollout dialog and isPoint2 newsize then
		(
			dialog.width=dlgsize.x=newsize.x
			dialog.height=dlgsize.x=newsize.y
			setdialogpos dialog (dlgOnScreen dialog (getdialogpos dialog))
			return dlgsize
		)else
		(
			--fatalerrormsg "<point2> slib.dlg.setSize <rollout> <point2>" (#(dlgsize,dialog,newsize))
		)
	),
	fn getSize dialog=						--get dialog size
	(
		local dlgsize=[0,0]
		if isRollout dialog then
		(
			dlgsize.x=dialog.width
			dlgsize.y=dialog.height
			return dlgsize
		)else
		(
			--fatalerrormsg "<point2> slib.dlg.getSize <rollout>" (#(dlgsize,dialog))
		)
	),
	fn resizeLim dialog newsize limitmin limitmax=		--note that 'limits' is point2 array !!! e.g. #([50,50],[500,500])
	(
		local dlgsize=newsize
		if isRollout dialog and isPoint2 newsize and isPoint2 limitmin and isPoint2 limitmax then
		(
			--check limits
			if dlgsize.x<limitmin.x do dlgsize.x=limitmin.x
			if dlgsize.y<limitmin.y do dlgsize.y=limitmin.y
			if dlgsize.x>limitmax.x do dlgsize.x=limitmax.x
			if dlgsize.y>limitmax.y do dlgsize.y=limitmax.y
			--resize dialog
			dialog.width=dlgsize.x
			dialog.height=dlgsize.y
			setdialogpos dialog (dlgOnScreen dialog (getdialogpos dialog))
		)else
		(
			--fatalerrormsg "<point2> slib.dlg.resizeLim <rollout> <point2> <point2> <point2>" (#(dlgsize,dialog,newsize,limitmin,limitmax))
		)
		return dlgsize
	),
	fn setPos dialog newpos=
	(
		if isRollout dialog and isPoint2 newpos then
		(
			setdialogpos dialog (dlgOnScreen dialog newpos)
		)else
		(
			errtxt="slib.dlg.setPos dialog newpos\n"
			errtxt+="slib.dlg.setPos <rollout> <point2>"
			--fatalerrormsg errtxt #(dialog,newsize)
		)
	),
	fn setPosCursor dialog=
	(
		if isRollout dialog then
		(
			local mousepos=[(mouse.screenpos.x),(mouse.screenpos.y)]
			local dlgpos=dlgOnScreen dialog mousepos
			
			if dlgpos.x<mousepos.x do dlgpos.x-=((dialog.width-(mousepos.x-dlgpos.x))+5)
			if dlgpos.y<mousepos.y do dlgpos.y-=((dialog.height-(mousepos.y-dlgpos.y))+27)
			setdialogpos dialog dlgpos
		)else
		(
			errtxt="slib.dlg.setPosCursor dialog\n"
			errtxt+="slib.dlg.setPosCursor <rollout>"
			--fatalerrormsg errtxt #(dialog)
		)
	),
	fn getPos dialog=
	(
		local dlg_pos=getDialogPos dialog
		return dlg_pos
	)
)
local wdlg
struct workingdlg_struct
(
	fn close=			--closes working dialog
	(
		gc()
		setArrowCursor()
		destroydialog wdlg
	),
	fn job jobStr=		--updates working dialog with custom text [needs var(s): maintitle]
	(
		try(
		wdlg.lblJob.text=jobStr
		wdlg.lblWait.text="Please Wait"
		wdlg.grpWork.text=maintitle
		wdlg.btn_close.pos=[270,8]
		)catch(
			--fatalerrormsg "workdlg.job <string>" #(jobStr)
		)
	),
	fn value val=
	(
		try(
		wdlg.lblJob.text=jobStr
		--wdlg.lblWait.text="Please Wait"
		local v=""
		if isInteger val do
		(
			if val>10 do val=10
			for i=0 to val do
			(
				v=v+"."
			)
		)
		wdlg.lblWait.text="Please Wait"+v
		wdlg.grpWork.text=maintitle
		wdlg.btn_close.pos=[270,8]
		)catch(
			--fatalerrormsg "workdlg.value <integer>" #(val)
		)
	),
	fn open=			--opens working dialog [needs var(s): maintitle]
	(
		setWaitCursor()
		gc()
		rollout wdlg "" width:296 height:112
		(
			button btn_close " x" pos:[270,8] width:21 height:21 tooltip:"Close"
			groupBox grpWork "-----main title-----" pos:[8,8] width:280 height:96
			label lblblank "" pos:[16,28] width:264 height:16
			label lblJob "--------------job-------------" --pos:[16,48] align:#center--width:264 height:16 
			label lblWait "Please Wait" --pos:[16,64] align:#center--width:264 height:16 align:#center
			
			
		
			on wdlg open do
			(
				grpWork.text=maintitle
				wdlg.btn_close.pos=[270,8]
			)
			on btn_close pressed do destroydialog wdlg
		)createdialog wdlg style:#(#style_border)
	)
)
fn copyarray array=
(
	local newarray=#()
	for i in array do
	(
		append newarray i
	)
	return newarray
)
struct sarray_struct
(
	fn getarray s_array div mode=		--returns whole array 	/#("12","8","JOU") getarray.arr "12x8xJOU" "x" 0
	(									--						/#(12,8) getarray.arr "12x8xJOU" "x" 1
		local returnarray=#()
		if isString s_array and isString div then
		(
			local returnarray=filterstring s_array div
			
			case mode of
			(
				0:(		-- string mode (returns every value in array as string)
					return returnarray
					)
				1:(		-- integer mode (returns only integer values into array)
					local temparray=#()
					temparray=copyarray returnarray
					returnarray=#()
					for val in temparray do
					(
						local intval=0
						try(
							intval=val as integer
							append returnarray intval
						)catch()
					)
					return returnarray
					)
			)
			
			return returnarray
		)else
		(
			errtxt="returnarray slib.sarray.getarray s_array div\n"
			errtxt+="<array> slib.sarray.getarray <string> <string>"
			--fatalerrormsg errtxt #(returnarray,s_array,div)
		)
	),
	fn getint s_array div num=
	(
		local returnnum=0
		if isString s_array and isString div and isInteger num and num!=0 then
		(
			local filtarray=filterstring s_array div
			if num<=filtarray.count do
			(
				try(
					returnnum=(filtarray[num] as integer)
					return returnnum
				)catch
				(
					returnnum=0
					errtxt="returnnum slib.sarray.getint s_array div num\n"
					errtxt+="<integer> slib.sarray.getint <string> <string> <integer>"
					--fatalerrormsg errtxt #(returnnum,s_array,div,num)
				)
			)
		)else
		(
			errtxt="returnnum slib.sarray.getint s_array div num\n"
			errtxt+="<integer> slib.sarray.getint <string> <string> <integer>"
			--fatalerrormsg errtxt #(returnnum,s_array,div,num)
		)
	),
	fn getstr s_array div num=
	(
		local returnstr="undefined"
		if isString s_array and isString div and isInteger num and num!=0 then
		(
			local filtarray=filterstring s_array div
			if num<=filtarray.count do
			(
				returnstr=filtarray[num]
			)
			return returnstr
		)else
		(
			errtxt="returnstr slib.sarray.getstr s_array div num\n"
			errtxt+="<string> slib.sarray.getstr <string> <string> <integer>"
			--fatalerrormsg errtxt #(returnstr,s_array,div,num)
		)
	),
	fn setval s_array div num val=
	(
		if isString s_array and isString div and isInteger num and num!=0 then
		(
			local newsarray=""
			local array=filterstring s_array div
			if num<=array.count do
			(
				array[num]=(val as string)
			)
			for i in array do
			(
				newsarray+=(i+div)
			)
			return newsarray
		)else
		(
			errtxt="slib.sarray.set s_array div num val\n"
			errtxt+="slib.sarray.set <string> <string> <integer> <value>"
			--fatalerrormsg errtxt #(s_array,div,num,val)
		)
	),
	fn append s_array div val=
	(
		local newsarray=s_array
		if isString s_array and isString div then
		(
			if newsarray!="" and newsarray[newsarray.count]!=div then
			(
				newsarray+=(div+(val as string))
			)else
			(
				newsarray+=(val as string)
			)
		)else
		(
			errtxt="newsarray slib.sarray.append s_array div val\n"
			errtxt+="<string> slib.sarray.count <string> <string> <anything>"
			--fatalerrormsg errtxt #(newsarray,s_array,div,val)
		)
		return newsarray
	),
	fn count s_array div=
	(
		local sarraycount=0
		if isString s_array then
		(
			local array=filterstring s_array div
			sarraycount=array.count
			return sarraycount
		)else
		(
			errtxt="sarraycount slib.sarray.count s_array div\n"
			errtxt+="<integer> slib.sarray.count <string> <string>"
			--fatalerrormsg errtxt #(sarraycount,s_array,div)
		)
	)
)
struct slib_struct
(
	fn hello=
	(messagebox "slib.hello - - - HELLO !!!" title:"santex function library"),
	fn tolowercase text=		--returns string in lowercase
	(
		local txt=text
		if isString text then
		(
			local lower="abcdefghijklmnopqrstuvwxyz"
			local upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
			local cnt=txt.count
			for i=1 to cnt do
			(
				local idx=(findstring upper txt[i])
				if idx!=undefined do
				(
					txt[i]=lower[idx]
				)
			)
			return txt
		)else
		(
			local failsafe="Undefined"
			errtxt="txt(failsafe) slib.tolowercase text\n"
			errtxt+="<string> slib.tolowercase <string>"
			--fatalerrormsg errtxt #(failsafe,text)
			return failsafe
		)
	),
	fn touppercase text=		--returns string in uppercase
	(
		local txt=text
		if isString text then
		(
			local lower="abcdefghijklmnopqrstuvwxyz"
			local upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
			local cnt=txt.count
			for i=1 to cnt do
			(
				local idx=(findstring lower txt[i])
				if idx!=undefined do
				(
					txt[i]=upper[idx]
				)
			)
			return txt
		)else
		(
			local failsafe="Undefined"
			errtxt="txt(failsafe) slib.touppercase text\n"
			errtxt+="<string> slib.touppercase <string>"
			--fatalerrormsg errtxt #(failsafe,text)
			return failsafe
		)
	),
	fn clearDups a=				--clears duplicates in array a, returns clear array
	(
		if isArray a then
		(
			local cleared=0
			local raw=a.count
			
			for i in a.count to 1 by -1 do 
			(
				idx=findItem a a[i]
				if (idx!=0) AND (idx!=i) then
				(
					cleared=cleared+1
					deleteItem a i
				)
			)
			return a
		)else
		(
			local failsafe=#()
			errtxt="a(failsafe) slib.clearDups a\n"
			errtxt+="<array> slib.clearDups <array>"
			--fatalerrormsg errtxt #(failsafe,a)
			return failsafe
		)
	),
	fn isCorrectMaxVersion correctVersion=
	(
		mVersion=maxVersion()
		if (mVersion[1]>=correctVersion) then return true else return false
	),
	fn getShortString txt maxlenght=
	(
		local rtext=txt
		local divtext=filterstring rtext "\\"
		
		if (rtext.count*5)>maxlenght then
		(
			rtext=(divtext[1]+"\\...\\"+divtext[divtext.count-1]+"\\"+divtext[divtext.count])
			
			if (rtext.count*5)>maxlenght then
			(
				rtext=(divtext[1]+"\\...\\"+divtext[divtext.count])
				return rtext
			)else
			(
				return rtext
			)
		)else
		(
			return rtext
		)
	),
	workdlg=workingdlg_struct(),
	dlg=dialogfunctions_struct(),
	data=scene_data_struct(),
	setting=settings_struct(),
	csetting=customfile_settings_struct(),
	file=filefunctions_struct(),
	sarray=sarray_struct()
)
local slib=slib_struct()